/*
 * This file is part of the Cforall project
 *
 * This class is intended to perform pre-processing of declarations, validating their
 * correctness and computing some auxilliary data that is necessary for the indexer.
 *
 * $Id: Validate.h,v 1.7 2005/08/29 20:14:18 rcbilson Exp $
 *
 */

#ifndef SYMTAB_VALIDATE_H
#define SYMTAB_VALIDATE_H

#include "SynTree/SynTree.h"

namespace SymTab {

class Indexer;

void validate( std::list< Declaration* > &translationUnit, bool doDebug = false,
               const Indexer *indexer = 0 );

void validateType( Type *type, const Indexer *indexer );

} // namespace SymTab

#endif /* #ifndef SYMTAB_VALIDATE_H */
